<?php

namespace Projects\Validator;

use Application\Validator\IsBool;
use Laminas\Validator\Exception;
use Laminas\Validator\StringLength;
use Projects\Model\IProject;

class Deploy extends \Application\Validator\AbstractValidator
{

    /**
     * @inheritDoc
     */
    public function isValid($value)
    {
        $errors           = [];
        $enabledValidator = new IsBool();
        $urlValidator     = new StringLength(['min'=>($value[IProject::DEPLOY_ENABLED]??false)?1:0]);
        if (!$enabledValidator->isValid($value[IProject::DEPLOY_ENABLED]??false)) {
            $errors[IProject::DEPLOY_ENABLED] = $enabledValidator->getMessages();
        }
        if (!$urlValidator->isValid($value[IProject::DEPLOY_URL]??"")) {
            $errors[IProject::DEPLOY_URL] = $urlValidator->getMessages();
        }
        if (count($errors)) {
            $this->abstractOptions['messages'][IProject::DEPLOY] = $errors;
            return false;
        }
        return true;
    }
}
